#!/usr/local/bin/perl
# -*- tab-width: 4 -*-
#$ontcgi_path = 'cgi-bin/ontcgi/';

require "${ontcgi_path}jcode.pl";
use Fcntl;
use AnyDBM_File;

sub warnMessage;		#Ƥ褤ǧ
sub deletePost;			#ꤵ줿ƤΡȤ
sub printPostTitles;	#ֿΥȥɽ

sub parseFormData;		#եǡϤ
sub errorMessage;		#顼åɽ
sub retryFlock;			#flock򷫤֤
sub retryRename;		#rename򷫤֤

@weekMoji  = ('', '', '', '', '', '', '');

require "${ontcgi_path}ontenv.pl";

&parseFormData();
$job		 = $in{'job'};		#եǲܥ
$note_no	 = $in{'no'};		#Ρֹ
$post_no	 = $in{'re'};		#ֹ(0ʤΡȼΤ)
$delPassword = $in{'passwd'};	#ѥѥ
$sysPassword = $in{'syspass'};	#ѥѥ

open(DMYFILE, "${ontcgi_path}data/ont_dmy")
		or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
flock(DMYFILE, 2);
tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
		or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

($userName, $email, $writeTime, $postNum, $profile,
		$remoteHOST, $remoteADDR, $cryptPasswd, $title)
		= split(/&/, $DBMFILE{"${note_no}:${post_no}"});

$cryptSyspass = $DBMFILE{'syspass'};
@notes_que = split(/&/, $DBMFILE{'queue'});
$pos_num = @pos = split(/&/, $DBMFILE{"${note_no}:IDX"});

untie %DBMFILE;
flock(DMYFILE, 8);
close(DMYFILE);

if (grep($_ == $note_no, @notes_que) == 0) {
	&errorMessage("** ˥塼ˤʤ${notes_name}򤵤ޤ **");
	exit(1);
}

if ($job eq '') {
	&deletePost();
}
else {
	&warnMessage();
}

### sub warnMessage() : Ƥ褤ǧ

sub warnMessage {
	$cookieData = $ENV{'HTTP_COOKIE'};
	$cookieData =~ s/ONT=//o;
	$cookieData =~ s/_sem_/;/go;
	@cookieData = split(/&/, $cookieData);

	for (@cookieData) {
		/^(.*?):(.*)$/;
		$key   = $1;
		$value = $2;
		$value =~ s/_amp_/&/go;
		$cookie{$key} = $value;
	}

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / Ƥ</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="30%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/${note_no}.html"></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> Ƥ </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="30%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<BR>
** ƤƤǤ **
<BR>
END

	open(NOTFILE, "${onthtml_path}/${note_no}.html")
			or die "NOTFILE=${onthtml_path}/${note_no}.html : $!";
	flock(NOTFILE, 2);

	if ($post_no > 0) {
		for ($i = 0; $i < ($pos_num - $post_no); $i++) {
			$pos += $pos[$i];
		}
		seek(NOTFILE, $pos, 0);
	}

	while (<NOTFILE>) {
		if (/^<TABLE width="95%"/oi) {
			print;
			last;
		}		
	}
	while (<NOTFILE>) {
		print;
		if (/^<\/TABLE>/o) {
			last;
		}
	}

	flock(NOTFILE, 8);
	close(NOTFILE);

	print <<END;
<FORM method="POST" action="ontdel.cgi">
<INPUT type="hidden" name="no" value="${note_no}">
<INPUT type="hidden" name="re" value="${post_no}">
<HR width="95%" size="1">
<TABLE width="95%">
<TR><TD align="left">ѥ<INPUT type="password" name="passwd" value="${cookie{'PASSWD'}}" size="8" MAXLENGTH="8">(ѿ8ʸ)</TD>
<TD align="right">ѥѥ<INPUT type="password" name="syspass" size="8" MAXLENGTH="8"></TD></TR>
</TABLE>
<INPUT type="submit" name="job" value=""><INPUT type="reset" value="ꥻå">
</FORM>
<BR>
<A name="end">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/${note_no}.html"></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END
}

### sub deletePost() : ꤵ줿ƤΡȤ

sub deletePost {
	if ($sysPassword ne '') {
		$crypted = crypt($sysPassword, $delPassword);
		$crypted =~ s/\$.*\$//;
		if ($crypted ne $cryptSyspass) {
			&errorMessage('** ѥѥɤäƤޤ **');
			exit(1);
		}
	}
	else {
		if ($post_no == 0 && $postNum > 0) {
			&errorMessage("** ǤƤä${notes_name}ϺǤޤ **");
			exit(1);
		}

		$writeTime =~ m!^.*/.*/(.*)\(.*\)(.*):(.*)$!o;
		$salt = $3 + $2 * 60 + $1 * 60 * 24;
		if (crypt($delPassword, $salt) ne $cryptPasswd) {
			&errorMessage("** ѥѥɤäƤޤ **");
			exit(1);
		}
	}

# Ƥå

	if ($post_no == 0) {
		$refreshHTML_URL = "${onthtml_url}/index.html";
	}
	else {
		$refreshHTML_URL = "${onthtml_url}/${note_no}.html";
	}

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<META http-equiv="Refresh" content="${retryFlock_num}; URL=${refreshHTML_URL}">
<TITLE>Open!NOTES / ޤ</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> Ƥޤ </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
</TR></TABLE>
<BR>
<TABLE border="0" cellspacing="0" width="95%">
<TR><TD bgcolor="${noteBodyColor}" align="center">
** ${userName}Ƥޤ **<BR>
<BR>
${retryFlock_num}äۤԤäƥΡȤɽʤ<A href="${refreshHTML_URL}"></A>򥯥åƤ<BR>
<BR>
Ƹ塢˥塼ΡȤƤʤȤϺɤ߹ߤƤ<BR>
</TD></TR>
</TABLE>
</DIV>
</BODY>
</HTML>
END

#ΡȤ

	open(DMYFILE, ">${ontcgi_path}data/ont_dmy")
			or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
	&retryFlock(\*DMYFILE, 2);
	tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDWR | O_CREAT,
	  0644 or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

		@notes_que = split(/&/, $DBMFILE{'queue'});

	if ($post_no == 0) {
		@notes_que = grep($_ != $note_no, @notes_que);
		$DBMFILE{'queue'} = join('&', @notes_que);

		for ($i = 0; $i <= $postNum; $i++) {
			delete $DBMFILE{"${note_no}:${i}"};
		}
		delete $DBMFILE{"${note_no}:IDX"};

		untie %DBMFILE;
		&retryFlock(\*DMYFILE, 8);
		close(DMYFILE);

		unlink("${onthtml_path}/${note_no}.html");
	}
	else {
		$delFlag = 1;
		$DBMFILE{"${note_no}:${post_no}"}
				= join('&', $userName, $email, $writeTime, $delFlag, $profile,
				$remoteHOST, $remoteADDR, $cryptPasswd, $title);

		$pos[$pos_num - $post_no] = 0;
	 	$DBMFILE{"${note_no}:IDX"} = join('&', @pos);

		untie %DBMFILE;
		&retryFlock(\*DMYFILE, 8);
		close(DMYFILE);

		open(NOTFILE, "${onthtml_path}/${note_no}.html")
				or die "NOTFILE=${onthtml_path}/${note_no}.html : $!";
		flock(NOTFILE, 2);
		open(TMPFILE, ">${onthtml_path}/${note_no}.tmp")
				or die "TMPFILE=${onthtml_path}/${note_no}.tmp : $!";
		&retryFlock(\*TMPFILE, 2);

		while (<NOTFILE>) {
			if (/^<A name="${post_no}">/oi) {
				last;
			}
			print TMPFILE;
		}
		while (<NOTFILE>) {
			if (/^<HR width="95%"/oi) {
				last;
			}
		}
		while (<NOTFILE>) {
			print TMPFILE;
		}

		&retryFlock(\*TMPFILE, 8);
		close(TMPFILE);
		flock(NOTFILE, 8);
		close(NOTFILE);

		&retryRename("${onthtml_path}/${note_no}.tmp",
					 "${onthtml_path}/${note_no}.html");
	}

#˥塼κ

	$currentTime = time;
	($sec, $min, $hour, $day, $mon, $year, $week) = localtime($currentTime);
	$year += ($year >= 80) ? 1900 : 2000;
	$writeTime = sprintf("%d/%d/%d(%s)%02d:%02d",
			$year, $mon + 1, $day, $weekMoji[$week], $hour, $min);

	open(DMYFILE, "${ontcgi_path}data/ont_dmy")
			or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
	flock(DMYFILE, 2);
	tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
			or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

	open(MNUFILE, ">${onthtml_path}/index.html")
			or die "MNUFILE=${onthtml_path}/index.html : $!";
	&retryFlock(\*MNUFILE, 2);

	print MNUFILE <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<META http-equiv="Expires" content="Tue, 20 Aug 1996 00:00:00 GMT">
<TITLE>${menuPageTitle}</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<A name="top"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A ${backFromMenu_url}></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> ${menuPageTitle} </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#end">Ǹ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<FORM method="POST" action="${ontcgi_url}/ontinput.cgi">
${writeTime}<INPUT type="submit" name="job" value="${notes_name}"><INPUT type="submit" name="job" value="${notes_name}ɽ">${mailToSysop}
</FORM>
END

	foreach $i (@notes_que) {
		($userName, $email, $writeTime, $postNum, $profile,
				$remoteHOST, $remoteADDR, $cryptPasswd, $title)
				= split(/&/, $DBMFILE{"${i}:0"});

		$userName =~ s/_amp_/&/go;
		$profile  =~ s/_amp_/&/go;
		$title 	  =~ s/_amp_/&/go;

		print MNUFILE <<END;
<TABLE width="95%" border="0" cellspacing="0">
<TR><TD bgcolor="${noteHeadColor}" align="left">${notes_name}${i} | <A href="${i}.html">${title}</A> ${userName} ${writeTime}</TD><TD bgcolor="${noteHeadColor}" align="right">(  ${postNum}  )</TD></TR>
END

		if ($postNum > 0) {
			&printPostTitles($i, $postNum);
		}		

		print MNUFILE "</TABLE>\n<BR>\n";
	}

	print MNUFILE <<END;
<A name="end"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A ${backFromMenu_url}></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#top">Ƭ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END

	&retryFlock(\*MNUFILE, 8);
	close(MNUFILE);

	untie %DBMFILE;
	flock(DMYFILE, 8);
	close(DMYFILE);
}


### sub printPostTitles() : ֿΥȥɽ
#
# (IN)
#	$note_no	:ֿɽΡֹ
#	$post_num	:ֿ

sub printPostTitles {
	my($note_no, $post_num) = @_;
	my($userName, $email, $writeTime, $postNum, $profile,
			 $remoteHOST, $remoteADDR, $password, $title);

	($sec, $min, $hour, $day, $mon, $year, $week)
			= localtime($currentTime - 30 * 60 * 60 * 24);
	$year += ($year >= 80) ? 1900 : 2000;
	$endDisplayTime = sprintf("%04d/%02d/%02d %02d:%02d",
			$year, $mon + 1, $day, $hour, $min);

	($sec, $min, $hour, $day, $mon, $year, $week)
			= localtime($currentTime - 7 * 60 * 60 * 24);
	$year += ($year >= 80) ? 1900 : 2000;
	$markDisplayTime = sprintf("%04d/%02d/%02d %02d:%02d",
			$year, $mon + 1, $day, $hour, $min);

	print MNUFILE <<END;
<TR><TD bgcolor="${noteBodyColor}" colspan="2" align="left">
END

	for ($j = $post_num; $j > 0; $j--) {
		($userName, $email, $writeTime, $delFlag, $profile,
				$remoteHOST, $remoteADDR, $password, $title)
				= split(/&/, $DBMFILE{"${note_no}:${j}"});

		if ($delFlag == 1) {	
			next;
		}

		$writeTime =~ m!^(.*)/(.*)/(.*)\(.+\)(.+)$!o;
		$writeTime_tmp = sprintf("%04d/%02d/%02d %s", $1, $2, $3, $4);

		if ($writeTime_tmp le $endDisplayTime) {
			last;
		}
		if ($writeTime_tmp gt $markDisplayTime) {
			print MNUFILE "(${j})+";
		}
		else {
			print MNUFILE "(${j}) ";
		}

		$userName =~ s/_amp_/&/go;
		$title 	  =~ s/_amp_/&/go;
		
		print MNUFILE <<END;
<A href="${note_no}.html#${j}">${title}</A> ${userName} ${writeTime}<BR>
END
	}
	print MNUFILE '</TD></TR>';
}


### sub parseFormData() :եǡϤ
#
# (OUT)
#	%IN		:եǡ

sub parseFormData {
	my($formData_buf, @formData); 

	if ($ENV{'REQUEST_METHOD'} =~ /^(?:POST|post)$/o) {
		read(STDIN, $formData_buf, $ENV{'CONTENT_LENGTH'});
	}
	else {
		$formData_buf = $ENV{'QUERY_STRING'};
	}

	@formData = split(/&/, $formData_buf);
	foreach (@formData) {
		($name, $value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		&jcode'convert(*value, 'euc');
		$in{$name} = $value;
	}
}

### sub errorMessage() :顼åɽ
#
# (IN)
#	$message	:ɽ륨顼å 

sub errorMessage {
	my($message) = @_;

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / 顼å</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FF3333"></FONT><FONT color="#FFFFFF"> 顼å </FONT><FONT color="#FF3333"></FONT></STRONG></TD>
</TR></TABLE>
<BR>
<TABLE width="95%" border="0" cellspacing="0" cellpadding="15">
<TR><TD bgcolor="${noteBodyColor}" align="center">
${message}<BR>
</TD></TR>
</TABLE>
<BR>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END
}
### sub retryFlock() :flock򷫤֤
#
# (IN)
#	$fh		:եϥɥ
#	$mode	:1=ͭå2=¾å8=å

sub retryFlock {
	my($fh, $mode) = @_;

	for ($i = 0; $i < $retryFlock_num; $i++) {
		if (flock($fh, $mode)) {
			return;
		}
		else {
			sleep 2;
		}
	}

	&errorMessage('** ϿǤʤäǽޤ **');
	exit(1);
}

### sub retryRename() :rename򷫤֤
#
# (IN)
#	$oldname	:Ťե̾
#	$newname	:ե̾

sub retryRename {
	my($oldname, $newname) = @_;

	for ($i = 0; $i < $retryFlock_num; $i++) {
		unlink($newname);
		if (!-e $newname && rename($oldname, $newname)) {
			return;
		}
		else {
			sleep 1;
		}
	}
	&errorMessage('** ϿǤʤäǽޤ **');
	exit(1);
}

# Open!NOTES 1.3e- (C)1998-2002 NetComplex Inc. All rights reserved. 
