#!/usr/local/bin/perl
# -*- tab-width: 4 -*-
#$ontcgi_path = 'cgi-bin/ontcgi/';

require "${ontcgi_path}jcode.pl";
use Fcntl;
use AnyDBM_File;

sub thanksMessage;	# Ƥؤδեåɽ
sub takeAwayNote;	# פʥΡȤ
sub printPostTitles;# ֿΥȥɽ

sub parseFormData;	# եǡϤ
sub char2Reference;	# üʸѴ
sub errorMessage;	# 顼åɽ
sub retryFlock;		# flock򷫤֤
sub retryRename;	# rename򷫤֤

@weekMoji  = ('', '', '', '', '', '', '');
@weekWord  = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
@monthWord = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
			  'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

$remoteHOST = $ENV{'REMOTE_HOST'};
$remoteADDR = $ENV{'REMOTE_ADDR'};
$currentTime = time;

require "${ontcgi_path}ontenv.pl";

&parseFormData();
$note_no  = $in{'no'};			#ֿΡֹ(̤ʤ١Ρ)
$userName = $in{'name'};		#Ƽ̾
$email	  = $in{'email'};		#ƼԤEmailɥ쥹
$profile  = $in{'profile'};		#ƼԤΥץե
$title	  = $in{'title'};		#ƤΥȥ
$contents = $in{'contents'};	#Ƥ
$link	  = $in{'link'};		#ƤΥ
$password = $in{'passwd'};		#ݤΥѥ

&char2Reference($userName, '_amp_');
&char2Reference($profile,  '_amp_');
&char2Reference($title,    '_amp_');
&char2Reference($contents, '&');
&char2Reference($link,     '&');

$contents =~ s/[\r\n]+$//o;
$contents =~ s/  /&nbsp;&nbsp;/go;

if ($link ne undef) {
	$link       =~ s!^http://!!o;
	$in{'link'} =~ s!^http://!!o;
	if ($contents ne undef) {
		$contents .= "\r\n\r\n";
	}
	$contents .= "<A href=\"http://${in{'link'}}\">http://${link}</A>";
}

if ($userName eq undef) {
	&errorMessage('** ̾ϤƤޤ **');
	exit(1);
}
if (length($userName) > 64) {
	&errorMessage('** ̾ĹȾ64ʸۤƤޤ **');
	exit(1);
}

if ($title eq undef) {
	&errorMessage('** ȥ뤬ϤƤޤ **');
	exit(1);
}
if (length($title) > 64) {
	&errorMessage('** ȥĹȾ64ʸۤƤޤ **');
	exit(1);
}

if (length($email) > 64) {
	&errorMessage('** E-mailɥ쥹ĹȾ64ʸۤƤޤ **');
	exit(1);
}
if (length($profile) > 64) {
	&errorMessage('** ʾҲ/ᶷĹȾ64ʸۤƤޤ **');
	exit(1);
}

if ($password !~ /\w{0,8}/) {
	&errorMessage('** ѥɤϱѿ8ʸǤ **');
	exit(1);
}

# DBMեؤϿ

($sec, $min, $hour, $day, $mon, $year, $week) = localtime($currentTime);
$year += ($year >= 80) ? 1900 : 2000;
$writeTime = sprintf("%d/%d/%d(%s)%02d:%02d",
		$year, $mon + 1, $day, $weekMoji[$week], $hour, $min);

$cryptPasswd = crypt($password, $min + $hour * 60 + $day * 60 * 24);

if (!-e "data/${ontcgi_path}ont_dmy") {
	open(DMYFILE, ">${ontcgi_path}data/ont_dmy");
	print DMYFILE '.';
	close(DMYFILE);
}

open(DMYFILE, ">${ontcgi_path}data/ont_dmy")
		or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
&retryFlock(\*DMYFILE, 2);
tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDWR | O_CREAT, 0644
		or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

($beforeTime, $beforeAddr) = split(/:/, $DBMFILE{'addrs'});
if ($beforeAddr eq $remoteADDR
		&& $beforeTime > $currentTime - $retryFlock_num) {
	untie %DBMFILE;
	&retryFlock(\*DMYFILE, 8);
	close(DMYFILE);

	&thanksMessage('index.html');
	exit(1);
}
$DBMFILE{'addrs'} = "${currentTime}:${remoteADDR}";

if ($note_no == 0) {
	$note_no = ++$DBMFILE{'num'};

	$postNum = 0;

	$DBMFILE{"${note_no}:${postNum}"}
			= join('&', $userName, $email, $writeTime, $postNum, $profile,
			$remoteHOST, $remoteADDR, $cryptPasswd, $title);

	@notes_que = split(/&/, $DBMFILE{'queue'});	#ΡȤκǸɲ
	unshift(@notes_que, $note_no);
	if (@notes_que > 30) {
		&takeAwayNote(pop(@notes_que));
	}
	$DBMFILE{'queue'} = join('&', @notes_que);
}
else {
	@noteData = split(/&/, $DBMFILE{"${note_no}:0"});
	$postNum  = ++$noteData[3];
	$DBMFILE{"${note_no}:0"} = join('&', @noteData);

	$delFlag = 0;
	$DBMFILE{"${note_no}:${postNum}"}
			= join('&',$userName, $email, $writeTime, $delFlag, $profile,
			$remoteHOST, $remoteADDR, $cryptPasswd, $title);


	@notes_que = split(/&/, $DBMFILE{'queue'});	#ΡȤν֤촹
	@notes_que = grep($_ != $note_no, @notes_que);
	unshift(@notes_que, $note_no);
	$DBMFILE{'queue'} = join('&', @notes_que);
}

untie %DBMFILE;
&retryFlock(\*DMYFILE, 8);
close(DMYFILE);

&thanksMessage("${note_no}.html");

# ΡȤκ/ɲ

$userName =~ s/_amp_/&/go;
$email 	  =~ s/_amp_/&/go;
$profile  =~ s/_amp_/&/go;
$title 	  =~ s/_amp_/&/go;

if ($email eq undef) {
	$nameAndEmail = $userName;
}
else {
	$nameAndEmail = "<A href=\"mailto:${email}\">${userName}</A>";
}

$contents =~ s/\r\n|\n|\r/<BR>/go;

if ($postNum == 0) {
	open(NOTFILE, ">${onthtml_path}/${note_no}.html")
			or die "NOTFILE=${onthtml_path}/${note_no}.html : $!";
	&retryFlock(\*NOTFILE, 2);

	print NOTFILE <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<META http-equiv="Expires" content="Tue, 20 Aug 1996 00:00:00 GMT">
<TITLE>Open!NOTES / ${notes_name}${note_no}</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<A name="top"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="30%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> ${notes_name}${note_no} </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="30%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#end">Ǹ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<FORM method="POST" action="${ontcgi_url}/ontinput.cgi">
<INPUT type="hidden" name="no" value="${note_no}">
<INPUT type="submit" name="job" value="${notes_name}"><INPUT type="submit" name="job" value="Ƥɽ">
</FORM>
<TABLE width="95%" border="0" cellspacing="0">
<TR><TD bgcolor="${noteHeadColor}" align="left">${notes_name}${note_no} | ${title} ${nameAndEmail} ${writeTime}</TD><TD bgcolor="${noteHeadColor}" align="right"><A href="${ontcgi_url}/ontinput.cgi?no=${note_no}&re=0">ֻ</A> / <A href="${ontcgi_url}/ontdel.cgi?no=${note_no}&re=0"></A></TD></TR>
<TR><TD bgcolor="${noteBodyColor}" colspan="2" align="left">
<BR>${contents}
<P align="right">( ${profile} )</P></TD></TR>
</TABLE>
<HR width="95%" size="1">
END

	$pos = tell(NOTFILE);

	print NOTFILE <<END;
<A name="end"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#top">Ƭ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END

	&retryFlock(\*NOTFILE, 8);
	close(NOTFILE);
}
else {
	open(NOTFILE, "${onthtml_path}/${note_no}.html")
			or die "NOTFILE=${onthtml_path}/${note_no}.html : $!";
	flock(NOTFILE, 2);
	open(TMPFILE, ">${onthtml_path}/${note_no}.tmp")
			or die "TMPFILE=${onthtml_path}/${note_no}.tmp : $!";
	&retryFlock(\*TMPFILE, 2);

	while (<NOTFILE>) {
		print TMPFILE;
		if (/^<HR width="95%"/oi) {
			last;
		}
	}

	print TMPFILE <<END;
<A name="${postNum}"></A>
<TABLE width="95%" border="0" cellspacing="0">
<TR><TD bgcolor="${noteBodyColor}" align="left">${postNum} | ${title} ${nameAndEmail} ${writeTime}</TD><TD bgcolor="${noteBodyColor}" align="right"><A href="${ontcgi_url}/ontinput.cgi?no=${note_no}&re=${postNum}">ֻ</A> / <A href="${ontcgi_url}/ontdel.cgi?no=${note_no}&re=${postNum}"></A></TD></TR>
<TR><TD bgcolor="#FFFFFF" colspan="2" align="left">
<BR>${contents}
<P align="right">( ${profile} )</P></TD></TR>
</TABLE>
<HR width="95%" size="1">
END

	$pos = tell(TMPFILE);

	while (<NOTFILE>) {
		print TMPFILE;
	}

	&retryFlock(\*TMPFILE, 8);
	close(TMPFILE);
	flock(NOTFILE, 8);
	close(NOTFILE);

	&retryRename("${onthtml_path}/${note_no}.tmp",
				 "${onthtml_path}/${note_no}.html");
}

#ǥåκ

open(DMYFILE, ">${ontcgi_path}data/ont_dmy")
		or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
&retryFlock(\*DMYFILE, 2);
tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDWR | O_CREAT, 0644
		or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

if ($postNum == 0) {
	$DBMFILE{"${note_no}:IDX"} = $pos;
}
else {
	@pos = split(/&/, $DBMFILE{"${note_no}:IDX"});
	$pos = $pos - $pos[0];
	splice(@pos, 1, 0, $pos);	#$pos@pos2ܤ
	$DBMFILE{"${note_no}:IDX"} = join('&', @pos);
} 

untie %DBMFILE;
&retryFlock(\*DMYFILE, 8);
close(DMYFILE);

#˥塼κ

open(DMYFILE, "${ontcgi_path}data/ont_dmy")
		or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
flock(DMYFILE, 2);
tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
		or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

open(MNUFILE, ">${onthtml_path}/index.html")
		or die "MNUFILE=${onthtml_path}/index.html : $!";
&retryFlock(\*MNUFILE, 2);

print MNUFILE <<END;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<META http-equiv="Expires" content="Tue, 20 Aug 1996 00:00:00 GMT">
<TITLE>${menuPageTitle}</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<A name="top"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A ${backFromMenu_url}></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> ${menuPageTitle} </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#end">Ǹ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<FORM method="POST" action="${ontcgi_url}/ontinput.cgi">
${writeTime}<INPUT type="submit" name="job" value="${notes_name}"><INPUT type="submit" name="job" value="${notes_name}ɽ">${mailToSysop}
</FORM>
END

foreach $i (@notes_que) {
	($userName, $email, $writeTime, $postNum, $profile,
			$remoteHOST, $remoteADDR, $cryptPasswd, $title)
			= split(/&/, $DBMFILE{"${i}:0"});

	$userName =~ s/_amp_/&/go;
	$profile  =~ s/_amp_/&/go;
	$title 	  =~ s/_amp_/&/go;

	print MNUFILE <<END;
<TABLE border="0" cellspacing="0" width="95%">
<TR><TD bgcolor="${noteHeadColor}" align="left">${notes_name}${i} | <A href="${i}.html">${title}</A> ${userName} ${writeTime}</TD><TD bgcolor="${noteHeadColor}" align="right">(  ${postNum}  )</TD></TR>
END

	if ($postNum > 0) {
		&printPostTitles($i, $postNum);
	}		

	print MNUFILE "</TABLE>\n<BR>\n";
}

print MNUFILE <<END;
<A name="end"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A ${backFromMenu_url}></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#top">Ƭ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END

&retryFlock(\*MNUFILE, 8);
close(MNUFILE);

untie %DBMFILE;
flock(DMYFILE, 8);
close(DMYFILE);


### sub thanksMessage() :Ƥؤδեåɽ
#
# (IN)
#	$reloadFile		:ɤե̾
#
sub thanksMessage {
	my($reloadFile) = @_;

($sec, $min, $hour, $day, $mon, $year, $week)
		= localtime($currentTime + 60 * 60 * 60 * 24);
$day  = sprintf("%02d", $day);
$year += ($year >= 80) ? 1900 : 2000;

$cookieData = "NAME:${userName}&EMAIL:${email}&PROFILE:${profile}&PASSWD:${password}&WRIPASS:";
$cookieData =~ s/;/_sem_/go;
#åʸƬ#Ϥ
#$cookieData =~ s/([\x80-\xFF])/sprintf("%%%x", ord($1))/eg;

	print <<END;
Content-type: text/html
Set-Cookie: ONT=${cookieData}; expires=${weekWord[$week]}, ${day}-${monthWord[$mon]}-${year} 00:00:00 GMT;

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<META http-equiv="Refresh" content="${retryFlock_num}; URL=${onthtml_url}/${reloadFile}">
<TITLE>Open!NOTES / Ƥ꤬Ȥޤ</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> Ƥ꤬Ȥޤ </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
</TR></TABLE>
<BR>
<TABLE width="95%" border="0" cellspacing="0">
<TR><TD bgcolor="${noteBodyColor}" align="center">
** ${userName}Ƥ꤬Ȥޤ **<BR>
<BR>
${retryFlock_num}äۤԤäƥΡȤɽʤ<A href="${onthtml_url}/${reloadFile}"></A>򥯥åƤ<BR>
<BR>
Ƹ塢˥塼ΡȤƤʤȤϺɤ߹ߤƤ<BR>
</TD></TR>
</TABLE>
</DIV>
</BODY>
</HTML>
END
}
 



### sub takeAwayNote() : פʥΡȤ
#
# (IN)
#	$cutNote_no	:ΡȤֹ

sub takeAwayNote {
	local($cutNote_no) = @_;
	local($userName, $email, $writeTime, $postNum, $profile,
			 $remoteHOST, $remoteADDR, $cryptPasswd, $title);

	unlink("${onthtml_path}/${cutNote_no}.html");

	($userName, $email, $writeTime, $postNum, $profile,
			$remoteHOST, $remoteADDR, $cryptPasswd, $title)
			= split(/&/, $DBMFILE{"${cutNote_no}:0"});

	for ($i = 0; $i <= $postNum; $i++) {
		delete $DBMFILE{"${cutNote_no}:${i}"};
	} 

	delete $DBMFILE{"${cutNote_no}:IDX"};
}

### sub printPostTitles() : ƤΥȥɽ
#
# (IN)
#	$note_no	:ƤɽΡֹ
#	$post_num	:

sub printPostTitles {
	my($note_no, $post_num) = @_;
	my($userName, $email, $writeTime, $postNum, $profile,
			 $remoteHOST, $remoteADDR, $cryptPasswd, $title);

	($sec, $min, $hour, $day, $mon, $year, $week)
			= localtime($currentTime - 30 * 60 * 60 * 24);
	$year += ($year >= 80) ? 1900 : 2000;
	$endDisplayTime = sprintf("%04d/%02d/%02d %02d:%02d",
			$year, $mon + 1, $day, $hour, $min);

	($sec, $min, $hour, $day, $mon, $year, $week)
			= localtime($currentTime - 7 * 60 * 60 * 24);
	$year += ($year >= 80) ? 1900 : 2000;
	$markDisplayTime = sprintf("%04d/%02d/%02d %02d:%02d",
			$year, $mon + 1, $day, $hour, $min);

	print MNUFILE <<END;
<TR><TD bgcolor="${noteBodyColor}" colspan="2" align="left">
END

	for ($j = $post_num; $j > 0; $j--) {
		($userName, $email, $writeTime, $delFlag, $profile,
				$remoteHOST, $remoteADDR, $cryptPasswd, $title)
				= split(/&/, $DBMFILE{"${note_no}:${j}"});

		if ($delFlag == 1) {	
			next;
		}

		$writeTime =~ m!^(.*)/(.*)/(.*)\(.+\)(.+)$!o;
		$writeTime_tmp = sprintf("%04d/%02d/%02d %s", $1, $2, $3, $4);

		if ($writeTime_tmp le $endDisplayTime) {
			last;
		}
		if ($writeTime_tmp gt $markDisplayTime) {
			print MNUFILE "(${j})+";
		}
		else {
			print MNUFILE "(${j}) ";
		}

		$userName =~ s/_amp_/&/go;
		$title 	  =~ s/_amp_/&/go;
		
		print MNUFILE <<END;
<A href="${note_no}.html#${j}">${title}</A> ${userName} ${writeTime}<BR>
END
	}
	print MNUFILE '</TD></TR>';
}


### sub parseFormData() :եǡϤ
#
# (OUT)
#	%IN		:եǡ

sub parseFormData {
	my($formData_buf, @formData); 

	if ($ENV{'REQUEST_METHOD'} =~ /^(?:POST|post)$/o) {
		read(STDIN, $formData_buf, $ENV{'CONTENT_LENGTH'});
	}
	else {
		$formData_buf = $ENV{'QUERY_STRING'};
	}

	@formData = split(/&/, $formData_buf);
	foreach (@formData) {
		($name, $value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		&jcode'convert(*value, 'euc');
		$in{$name} = $value;
	}
}

### sub char2Reference() : üʸѴ
#
# (IN)
#	$_[0]	:Ѵʸ
#	$_[1]	:&ΰ

sub char2Reference {
	$_[0] =~ s/&/$_[1]amp;/go;
	$_[0] =~ s/</$_[1]lt;/go;
	$_[0] =~ s/>/$_[1]gt;/go;
	$_[0] =~ s/"/$_[1]quot;/go;
}

### sub errorMessage() :顼åɽ
#
# (IN)
#	$message	:ɽ륨顼å 

sub errorMessage {
	my($message) = @_;

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / 顼å</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FF3333"></FONT><FONT color="#FFFFFF"> 顼å </FONT><FONT color="#FF3333"></FONT></STRONG></TD>
</TR></TABLE>
<BR>
<TABLE width="95%" border="0" cellspacing="0" cellpadding="15">
<TR><TD bgcolor="${noteBodyColor}" align="center">
${message}<BR>
</TD></TR>
</TABLE>
<BR>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END
}

### sub retryFlock() :flock򷫤֤
#
# (IN)
#	$fh		:եϥɥ
#	$mode	:1=ͭå2=¾Ūå8=å

sub retryFlock {
	my($fh, $mode) = @_;

	for ($i = 0; $i < $retryFlock_num; $i++) {
		if (flock($fh, $mode)) {
			return;
		}
		else {
			sleep 1;
		}
	}

	&errorMessage('** ϿǤʤäǽޤ **');
	exit(1);
}

### sub retryRename() :rename򷫤֤
#
# (IN)
#	$oldname	:Ťե̾
#	$newname	:ե̾

sub retryRename {
	my($oldname, $newname) = @_;

	for ($i = 0; $i < $retryFlock_num; $i++) {
		unlink($newname);
		if (!-e $newname && rename($oldname, $newname)) {
			return;
		}
		else {
			sleep 1;
		}
	}
	&errorMessage('** ϿǤʤäǽޤ **');
	exit(1);
}

# Open!NOTES 1.3e- (C)1998-2002 NetComplex Inc. All rights reserved. 

