#!/usr/local/bin/perl
# -*- tab-width: 4 -*-
#$ontcgi_path = 'cgi-bin/ontcgi/';

require "${ontcgi_path}jcode.pl";
use Fcntl;
use AnyDBM_File;

sub printAllTopic;	#ΡȤɽ
sub printAllPost;	#Ƥɽ

sub parseFormData;	#եǡϤ
sub errorMessage;	#顼åɽ

require "${ontcgi_path}ontenv.pl";

&parseFormData();
$job	 = $in{'job'};	#եಡܥ
$note_no = $in{'no'};	#ֿΡֹ(̤ʤ鿷˥ΡȺ)
$post_no = $in{'re'};	#ֹֿ(0ʤ١ΡȤֿ)

if (-e "${ontcgi_path}data/ont_dmy") {
	open(DMYFILE, "${ontcgi_path}data/ont_dmy")
			or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
	flock(DMYFILE, 2);
	tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
			or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

	$postPassword = $DBMFILE{'wripass'};
	@notes_que = split(/&/, $DBMFILE{'queue'});

	untie %DBMFILE;
	flock(DMYFILE, 8);
	close(DMYFILE);
}

if ($note_no ne undef && grep($_ == $note_no, @notes_que) == 0) {
	&errorMessage("** ˥塼ˤʤ${notes_name}ꤵޤ **");
	exit(1);
}

if ($job eq "${notes_name}ɽ") {
	&printAllTopic();
	exit(0);
} elsif ($job eq 'Ƥɽ') {
	&printAllPost($note_no);
	exit(0);
}

if ($note_no eq undef) {
	$thisPageTitle = "${notes_name}";
	$backAnchor = "<A href=\"${onthtml_url}/index.html\">˥塼</A>";
	$note_no = 0;
} else {
	$thisPageTitle = "${notes_name}${note_no}Ƥ";
	$backAnchor = "<A href=\"${onthtml_url}/${note_no}.html\"></A>";
}

$cookieData = $ENV{'HTTP_COOKIE'};
$cookieData =~ s/ONT=//o;
$cookieData =~ s/_sem_/;/go;
#åʸƬ#Ϥ
#$cookieData =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
@cookieData = split(/&/, $cookieData);

for (@cookieData) {
	/^(.*?):(.*)$/;
	$key   = $1;
	$value = $2;
	$value =~ s/_amp_/&/go;
	$cookie{$key} = $value;
}

$textarea_rows = ($ENV{'HTTP_USER_AGENT'} =~ /lynx/i) ? 25 : 12;

print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / ${thisPageTitle}</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<A name="top">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="30%" align="left"><STRONG><FONT color="#FFFFFF">${backAnchor}</FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC""></FONT><FONT color="#FFFFFF"> ${thisPageTitle} </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="30%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<FORM method="POST" action="ontwrite.cgi" accept-charset="EUC-JP,Shift_JIS">
<INPUT type="hidden" name="no" value="${note_no}">
<TABLE border="0" cellspacing="2">
<TR>
<TD bgcolor="${noteHeadColor}" align="left">̾</TD>
<TD bgcolor="${noteBodyColor}" align="left"><INPUT type="text" name="name" value="${cookie{'NAME'}}" size="64" maxlength="64">(ɬܹ)</TD>
</TR>
<TR>
<TD bgcolor="${noteHeadColor}" align="left">E-mailɥ쥹</TD>
<TD bgcolor="${noteBodyColor}" align="left"><INPUT type="text" name="email" value="${cookie{'EMAIL'}}" size="64" maxlength="64"></TD>
</TR>
<TR>
<TD bgcolor="${noteHeadColor}" align="left">ʾҲ/ᶷ</TD>
<TD bgcolor="${noteBodyColor}" align="left"><INPUT type="text" name="profile" value="${cookie{'PROFILE'}}" size="64" maxlength="64"></TD>
</TR>
<TR>
<TD bgcolor="${noteHeadColor}" align="left">ȥ</TD>
END

if ($post_no eq undef) {
	print <<END;
<TD bgcolor="${noteBodyColor}" align="left"><INPUT type="text" name="title" size="64" maxlength="64">(ɬܹ)</TD>
</TR>
<TR>
<TD bgcolor="${noteHeadColor}" align="left"></TD>
<TD bgcolor="${noteBodyColor}" align="left"><TEXTAREA name="contents" cols="80" rows="${textarea_rows}"></TEXTAREA></TD>
</TR>
END
} else {
	open(DMYFILE, "${ontcgi_path}data/ont_dmy")
			or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
	flock(DMYFILE, 2);
	tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
			or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

	($userName, $email, $writeTime, $postNum, $profile,
			$remoteHOST, $remoteADDR, $password, $title)
			= split(/&/, $DBMFILE{"${note_no}:${post_no}"});

	$pos_num = @pos = split(/&/, $DBMFILE{"${note_no}:IDX"});

	untie %DBMFILE;
	flock(DMYFILE, 8);
	close(DMYFILE);

	$userName =~ s/_amp_/&/go;
	$title 	  =~ s/_amp_/&/go;
	$title    =~ s/^(?:Re:)*/Re:/io;

	open(NOTFILE, "${onthtml_path}/${note_no}.html")
			or die "NOTFILE=${onthtml_path}/${note_no}.html : $!";
	flock(NOTFILE, 2);

	if ($post_no > 0) {
		for ($i = 0; $i < ($pos_num - $post_no); $i++) {
			$pos += $pos[$i];
		}
		seek(NOTFILE, $pos, 0);
	}

	while (<NOTFILE>) {
		if (/^<BR>/o) {
			$contents = $_;
			last;
		} elsif (/^<HR/o) {
			last;
		}
	}

	flock(NOTFILE, 8);
	close(NOTFILE);

	if ($contents eq undef || $contents eq "<BR>\n") {
		$contents = '';
	} else {
		$contents =~ s/<A.*>(.*)<\/A>$/$1/o;
		$contents =~ s/<BR>/\n> /go;
		$contents =~ s/&nbsp;/ /go;
		$contents = "( ${userName}${writeTime}˽񤭤ޤ )${contents}";
	}

	print <<END;
<TD bgcolor="${noteBodyColor}" align="left"><INPUT type="text" name="title" value="${title}" size="64" maxlength="64"></TD>
</TR>
<TR>
<TD bgcolor="${noteHeadColor}" align="left"></TD>
<TD bgcolor="${noteBodyColor}" align="left"><TEXTAREA name="contents" cols="80" rows="12">${contents}
</TEXTAREA></TD>
</TR>
END
}

print <<END;
<TR>
<TD bgcolor="${noteHeadColor}" align="left">URL</TD>
<TD bgcolor="${noteBodyColor}" align="left">http://<INPUT type="text" name="link" size="64" maxlength="200"></TD>
</TR>
<TR>
<TD bgcolor="${noteHeadColor}" align="left">ѥ</TD>
<TD bgcolor="${noteBodyColor}" align="left"><INPUT type="password" name="passwd" value="${cookie{'PASSWD'}}" size="8" maxlength="8">(ѿ8ʸ/ꤹ¾ͤǤʤʤޤ)</TD>
</TR>
</TABLE>
<INPUT type="submit" value="Ƥ"><INPUT type="reset" value="ꥻå">
</FORM>
<A name="end">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF">${backAnchor}</FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END

### sub printAllTopic() :ΡȤɽ

sub printAllTopic {
	my(@notes_que);
	my($userName, $email, $writeTime, $postNum, $profile,
	  $remoteHOST, $remoteADDR, $password, $title);

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / ${notes_name}ɽ</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<A name="top"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> ${notes_name}ɽ </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#end">Ǹ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<BR>
END

	open(DMYFILE, "${ontcgi_path}data/ont_dmy")
			or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
	flock(DMYFILE, 2);
	tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
			or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

	@notes_que = split(/&/, $DBMFILE{'queue'});
	$notes_num = @notes_que;

	print <<END;
( ${notes_name} ${notes_num}  )<BR>
END

	foreach $i (@notes_que) {
		($userName, $email, $writeTime, $postNum, $profile,
				$remoteHOST, $remoteADDR, $password, $title)
				= split(/&/, $DBMFILE{"${i}:0"});

		$userName =~ s/_amp_/&/go;
		$title 	  =~ s/_amp_/&/go;

	print <<END;
<TABLE width="95%" border="0" cellspacing="0">
<TR><TD bgcolor="${noteHeadColor}" align="left">${notes_name}${i} | <A href="${onthtml_url}/${i}.html">${title}</A> ${userName} ${writeTime}</TD><TD bgcolor="${noteHeadColor}" align="right">(  ${postNum}  )</TD></TR>
</TABLE>
<BR>
END
	}
	untie %DBMFILE;
	flock(DMYFILE, 8);
	close(DMYFILE);

	print <<END;
<A name="end"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#top">Ƭ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END
}

### sub printAllPost() :Ƥɽ

sub printAllPost {
	my($note_no) = @_;
	my($userName, $email, $writeTime, $postNum, $profile,
	   $remoteHOST, $remoteADDR, $password, $title);

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / Ƥɽ</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<A name="top"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/${note_no}.html"></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#00CCCC"></FONT><FONT color="#FFFFFF"> Ƥɽ </FONT><FONT color="#00CCCC"></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#end">Ǹ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
<BR>
END

	open(DMYFILE, "${ontcgi_path}data/ont_dmy")
			or die "DMYFILE=${ontcgi_path}data/ont_dmy : $!";
	flock(DMYFILE, 2);
	tie %DBMFILE, AnyDBM_File, "${ontcgi_path}data/ont_dbm", O_RDONLY, 0644
			or die "DBMFILE=${ontcgi_path}data/ont_dbm : $!";

	($userName, $email, $writeTime, $postNum, $profile,
			$remoteHOST, $remoteADDR, $password, $title)
			= split(/&/, $DBMFILE{"${note_no}:0"});

	$userName =~ s/_amp_/&/go;
	$title 	  =~ s/_amp_/&/go;

	print <<END;
<TABLE width="95%" border="0" cellspacing="0">
<TR><TD bgcolor="${noteHeadColor}" align="left">${notes_name}${note_no} | <A href="${onthtml_url}/${note_no}.html">${title}</A> ${userName} ${writeTime}</TD><TD bgcolor="${noteHeadColor}" align="right">(  ${postNum}  )</TD></TR>
END

	if ($postNum > 0) {
		print <<END;
<TR><TD bgcolor="${noteBodyColor}" colspan="2" align="left">
END

		for ($j = $postNum; $j > 0; $j--) {
			($userName, $email, $writeTime, $delFlag, $profile,
					$remoteHOST, $remoteADDR, $password, $title)
					= split(/&/, $DBMFILE{"${note_no}:${j}"});

			if ($delFlag == 1) {	
				next;
			}

			printf("(%02d) ", $j);

			$userName =~ s/_amp_/&/go;
			$title 	  =~ s/_amp_/&/go;
		
		print <<END;
<A href="${onthtml_url}/${note_no}.html#${j}">${title}</A> ${userName} ${writeTime}<BR>
END
		}		
		print '</TD></TR>';
	}
	untie %DBMFILE;
	flock(DMYFILE, 8);
	close(DMYFILE);

	print <<END;
</TABLE>
<BR>
<A name="end"></A>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/${note_no}.html"></A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="#top">Ƭ</A> <A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END
}


### sub parseFormData() :եǡϤ
#
# (OUT)
#	%IN		:եǡ

sub parseFormData {
	my($formData_buf, @formData); 

	if ($ENV{'REQUEST_METHOD'} =~ /^(?:POST|post)$/o) {
		read(STDIN, $formData_buf, $ENV{'CONTENT_LENGTH'});
	} else {
		$formData_buf = $ENV{'QUERY_STRING'};
	}

	@formData = split(/&/, $formData_buf);
	foreach (@formData) {
		($name, $value) = split(/=/);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		&jcode'convert(*value, 'euc');
		$in{$name} = $value;
	}
}

### sub errorMessage() :顼åɽ
#
# (IN)
#	$message	:ɽ륨顼å 

sub errorMessage {
	my($message) = @_;

	print <<END;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
        "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<META http-equiv="Content-type" content="text/html; charset=EUC-JP">
<TITLE>Open!NOTES / 顼å</TITLE>
</HEAD>

<BODY ${bodyTagOption}>
<DIV align="center">
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FF3333"></FONT><FONT color="#FFFFFF"> 顼å </FONT><FONT color="#FF3333"></FONT></STRONG></TD>
</TR></TABLE>
<BR>
<TABLE width="95%" border="0" cellspacing="0" cellpadding="15">
<TR><TD bgcolor="${noteBodyColor}" align="center">
${message}<BR>
</TD></TR>
</TABLE>
<BR>
<TABLE width="100%" border="0" cellspacing="0"><TR>
<TD bgcolor="#000000" width="25%" align="left"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/index.html">˥塼</A></FONT></STRONG></TD>
<TD bgcolor="#000000" align="center"><STRONG><FONT color="#FFFFFF">Open</FONT><FONT color="#FF3333">!</FONT><FONT color="#FFFFFF">NOTES 1.3e- (C) <A href="http://www.netcomplex.co.jp/">NetComplex Inc.</A></FONT></STRONG></TD>
<TD bgcolor="#000000" width="25%" align="right"><STRONG><FONT color="#FFFFFF"><A href="${onthtml_url}/help.html">إ</A></FONT></STRONG></TD>
</TR></TABLE>
</DIV>
</BODY>
</HTML>
END
}

# Open!NOTES 1.3e- (C)1998-2002 NetComplex Inc. All rights reserved.
